let mongoose = require('mongoose')

let middlewares = function() {
    
    this.mongodb = null
    this.mongoCredentials = null
    this.setMongoCredentials = (mongoCredentials) => {
        this.mongoCredentials = mongoCredentials
    }
    this.mongoConnect = () => {
        if(this.mongoCredentials == null) throw('You must set the mongoCredentials for this object!')
        else {
            this.mongodb = mongoose.createConnection('mongodb://' + this.mongoCredentials.user + ':' + this.mongoCredentials.passwd + this.mongoCredentials.url)
        }
    }

    this.getUserMongoCredentialsFromApiKey = (req, res, next) => {
        let apikey = req.headers.authorization ? req.headers.authorization : null
        if(apikey == null) throw 'You must send the apikey in the headers!'
        else if(this.mongodb == null) throw 'You must set up the mongoConnection for this object!' 
        else {
            let mongoCredentials = require('.././schemas/mongoCredentials.schema')(this.mongodb)
            mongoCredentials.find({apikeys: {$elemMatch: {key: apikey.slice(7)}}}, 'id name title mongodb', function(err, document) {
                if(err) {
                    req.account = null
                    next()
                } 
                else {
                    req.account = document[0]
                    next()
                }
            })
        }
    }
}

module.exports = middlewares